; 
    include \masm32\include\masm32rt.inc
; 
    .data
      hInstance   dd 0
      hHook       dd 0
      hwndEdit1   dd 0
      hwndEdit2   dd 0
      hwndButton1 dd 0
      hwndButton2 dd 0
      fIgnore     dd 0
     .code
; 

MessageProc proc code:DWORD, wParam:WPARAM, lParam:LPARAM

    push ebx
    .IF code == MSGF_DIALOGBOX
      mov ebx, lParam
      .IF [ebx].MSG.message == WM_KEYDOWN

        .IF [ebx].MSG.wParam == VK_RETURN

          invoke GetFocus
          SWITCH eax
            CASE hwndEdit1

              invoke SetFocus, hwndEdit2

            CASE hwndEdit2

              ;----------------------------------------------
              ; Set a flag to the window procedure will know
              ; to ignore the next BN_CLICKED notification.
              ;----------------------------------------------

              mov fIgnore, 1

              ;--------------------------------------------------
              ; Make button C the default button by forcing the
              ; style to BS_DEFPUSHBUTTON. To avoid disturbing
              ; the other style bits, this code gets the current
              ; value, sets bit0, and then writes the value back.
              ; By changing the OR to an XOR this same code can
              ; be use to force the style to BS_PUSHBUTTON.
              ;--------------------------------------------------

              invoke GetWindowLong, hwndButton1, GWL_STYLE
              or eax, 1
              invoke SetWindowLong, hwndButton1, GWL_STYLE, eax

              ;---------------------------------------------
              ; Add the button to the update region so it's
              ; appearance will be updated to match the new
              ; style on the next paint.
              ;---------------------------------------------

              invoke InvalidateRgn, hwndButton1, NULL, FALSE

              invoke SetFocus, hwndButton1

            CASE hwndButton1

              ;-----------------------------------------
              ; Navigating to the next button here will
              ; disable the BN_CLICKED notification.
              ;-----------------------------------------

            CASE hwndButton2

              ;---------------------------------------
              ; Navigating to Edit1 here will disable
              ; the BN_CLICKED notification.
              ;---------------------------------------

          ENDSW

        .ENDIF
      .ENDIF
    .ENDIF
    pop ebx

    ;-----------------------------------------
    ; Return whatever CallNextHookEx returns.
    ;-----------------------------------------

    invoke CallNextHookEx, hHook, code, wParam, lParam
    ret

MessageProc endp

; 

DlgProc proc hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDlgItem, hDlg, 100
        mov hwndEdit1, eax
        invoke GetDlgItem, hDlg, 101
        mov hwndEdit2, eax
        invoke GetDlgItem, hDlg, 102
        mov hwndButton1, eax
        invoke GetDlgItem, hDlg, 103
        mov hwndButton2, eax

        ;------------------------------------------------
        ; Install a WH_MSGFILTER hook so our MessageProc
        ; callback can intercept the dialog's messages.
        ;------------------------------------------------

        invoke GetCurrentThreadId
        invoke SetWindowsHookEx, WH_MSGFILTER, ADDR MessageProc, 0, eax

      CASE WM_COMMAND

        ;--------------------------------------------------------
        ; This switch block is actually handling the BN_CLICKED
        ; notification. For a WM_COMMAND message from a control
        ; the low-order word of wParam contains the control
        ; identifier and the high-order word the notification
        ; code. Because BN_CLICKED is actually zero, we need
        ; only compare wParam to the control identifier.
        ;--------------------------------------------------------

        SWITCH wParam

          CASE 102

            ;------------------------------------------------------
            ; If the flag is set, clear it so the next BN_CLICKED
            ; notification will be processed. If the flag is clear,
            ; process the BN_CLICKED notification.
           ;------------------------------------------------------

            .IF fIgnore
              mov fIgnore, 0
            .ELSE
              invoke MessageBox, hDlg, chr$("Button C"), chr$(" "),0
            .ENDIF

          CASE 103

            invoke MessageBox, hDlg, chr$("Button D"), chr$(" "),0

          CASE IDCANCEL

            invoke UnhookWindowsHookEx, hHook
            invoke EndDialog, hDlg, 0

        ENDSW

      CASE WM_CLOSE

        invoke UnhookWindowsHookEx, hHook
        invoke EndDialog, hDlg, 0

    ENDSW
    xor eax, eax
    ret
DlgProc endp

; 
start:
; 

    invoke GetModuleHandle, NULL
    mov hInstance, eax
    Dialog "Test", \
           "MS Sans Serif",10, \
           WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
           4,0,0,120,90,1024

    DlgEdit        WS_TABSTOP or WS_BORDER, 20, 10, 80, 12, 100
    DlgEdit        WS_TABSTOP or WS_BORDER, 20, 32, 80, 12, 101
    DlgButton "C", WS_TABSTOP, 30, 55, 25, 12, 102
    DlgButton "D", WS_TABSTOP, 65, 55, 25, 12, 103

    ;BS_DEFPUSHBUTTON

    CallModalDialog hInstance, 0, DlgProc, NULL
    exit
; 
end start
